"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from pybusinesscentral.api_client import ApiClient, Endpoint as _Endpoint
from pybusinesscentral.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from pybusinesscentral.model.dimension_set_line import DimensionSetLine


class DimensionSetLineApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_dimension_set_lines_for_sales_invoice_line_endpoint = _Endpoint(
            settings={
                'response_type': (DimensionSetLine,),
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/salesInvoices({salesInvoice_id})/salesInvoiceLines({salesInvoiceLine_id})/dimensionSetLines',
                'operation_id': 'get_dimension_set_lines_for_sales_invoice_line',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'sales_invoice_id',
                    'sales_invoice_line_id',
                ],
                'required': [
                    'company_id',
                    'sales_invoice_id',
                    'sales_invoice_line_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'sales_invoice_id':
                        (str,),
                    'sales_invoice_line_id':
                        (str,),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'sales_invoice_id': 'salesInvoice_id',
                    'sales_invoice_line_id': 'salesInvoiceLine_id',
                },
                'location_map': {
                    'company_id': 'path',
                    'sales_invoice_id': 'path',
                    'sales_invoice_line_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.post_dimension_set_line_endpoint = _Endpoint(
            settings={
                'response_type': (DimensionSetLine,),
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/salesInvoices({salesInvoice_id})/salesInvoiceLines({salesInvoiceLine_id})/dimensionSetLines',
                'operation_id': 'post_dimension_set_line',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'sales_invoice_id',
                    'sales_invoice_line_id',
                    'content_type',
                    'dimension_set_line',
                ],
                'required': [
                    'company_id',
                    'sales_invoice_id',
                    'sales_invoice_line_id',
                    'content_type',
                    'dimension_set_line',
                ],
                'nullable': [
                    'dimension_set_line',
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'sales_invoice_id':
                        (str,),
                    'sales_invoice_line_id':
                        (str,),
                    'content_type':
                        (str,),
                    'dimension_set_line':
                        (DimensionSetLine,),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'sales_invoice_id': 'salesInvoice_id',
                    'sales_invoice_line_id': 'salesInvoiceLine_id',
                    'content_type': 'Content-Type',
                },
                'location_map': {
                    'company_id': 'path',
                    'sales_invoice_id': 'path',
                    'sales_invoice_line_id': 'path',
                    'content_type': 'header',
                    'dimension_set_line': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def get_dimension_set_lines_for_sales_invoice_line(
        self,
        company_id,
        sales_invoice_id,
        sales_invoice_line_id,
        **kwargs
    ):
        """Retrieve the properties and relationships of the list of dimensionSetLines for a salesInvoiceLine.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_dimension_set_lines_for_sales_invoice_line(company_id, sales_invoice_id, sales_invoice_line_id, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company
            sales_invoice_id (str): (v1.0) id for salesInvoice
            sales_invoice_line_id (str): (v1.0) id for salesInvoiceLine

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            DimensionSetLine
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        kwargs['sales_invoice_id'] = \
            sales_invoice_id
        kwargs['sales_invoice_line_id'] = \
            sales_invoice_line_id
        return self.get_dimension_set_lines_for_sales_invoice_line_endpoint.call_with_http_info(**kwargs)

    def post_dimension_set_line(
        self,
        company_id,
        sales_invoice_id,
        sales_invoice_line_id,
        content_type,
        dimension_set_line,
        **kwargs
    ):
        """Creates an object of type dimensionSetLine in Dynamics 365 Business Central  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.post_dimension_set_line(company_id, sales_invoice_id, sales_invoice_line_id, content_type, dimension_set_line, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company
            sales_invoice_id (str): (v1.0) id for salesInvoice
            sales_invoice_line_id (str): (v1.0) id for salesInvoiceLine
            content_type (str): (v1.0) application/json
            dimension_set_line (DimensionSetLine):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            DimensionSetLine
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        kwargs['sales_invoice_id'] = \
            sales_invoice_id
        kwargs['sales_invoice_line_id'] = \
            sales_invoice_line_id
        kwargs['content_type'] = \
            content_type
        kwargs['dimension_set_line'] = \
            dimension_set_line
        return self.post_dimension_set_line_endpoint.call_with_http_info(**kwargs)

