"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from pybusinesscentral.api_client import ApiClient, Endpoint as _Endpoint
from pybusinesscentral.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from pybusinesscentral.model.inline_response2008 import InlineResponse2008
from pybusinesscentral.model.purchase_invoice import PurchaseInvoice


class PurchaseInvoiceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.delete_purchase_invoice_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/purchaseInvoices({purchaseInvoice_id})',
                'operation_id': 'delete_purchase_invoice',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'purchase_invoice_id',
                ],
                'required': [
                    'company_id',
                    'purchase_invoice_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'purchase_invoice_id':
                        (str,),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'purchase_invoice_id': 'purchaseInvoice_id',
                },
                'location_map': {
                    'company_id': 'path',
                    'purchase_invoice_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_purchase_invoice_endpoint = _Endpoint(
            settings={
                'response_type': (PurchaseInvoice,),
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/purchaseInvoices({purchaseInvoice_id})',
                'operation_id': 'get_purchase_invoice',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'purchase_invoice_id',
                    'expand',
                    'select',
                ],
                'required': [
                    'company_id',
                    'purchase_invoice_id',
                ],
                'nullable': [
                ],
                'enum': [
                    'expand',
                    'select',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('expand',): {

                        "PURCHASEINVOICELINES": "purchaseInvoiceLines",
                        "PDFDOCUMENT": "pdfDocument",
                        "VENDOR": "vendor",
                        "CURRENCY": "currency"
                    },
                    ('select',): {

                        "ID": "id",
                        "NUMBER": "number",
                        "INVOICEDATE": "invoiceDate",
                        "DUEDATE": "dueDate",
                        "VENDORINVOICENUMBER": "vendorInvoiceNumber",
                        "VENDORID": "vendorId",
                        "VENDORNUMBER": "vendorNumber",
                        "VENDORNAME": "vendorName",
                        "PAYTONAME": "payToName",
                        "PAYTOCONTACT": "payToContact",
                        "PAYTOVENDORID": "payToVendorId",
                        "PAYTOVENDORNUMBER": "payToVendorNumber",
                        "SHIPTONAME": "shipToName",
                        "SHIPTOCONTACT": "shipToContact",
                        "BUYFROMADDRESS": "buyFromAddress",
                        "PAYTOADDRESS": "payToAddress",
                        "SHIPTOADDRESS": "shipToAddress",
                        "CURRENCYID": "currencyId",
                        "CURRENCYCODE": "currencyCode",
                        "PRICESINCLUDETAX": "pricesIncludeTax",
                        "DISCOUNTAMOUNT": "discountAmount",
                        "DISCOUNTAPPLIEDBEFORETAX": "discountAppliedBeforeTax",
                        "TOTALAMOUNTEXCLUDINGTAX": "totalAmountExcludingTax",
                        "TOTALTAXAMOUNT": "totalTaxAmount",
                        "TOTALAMOUNTINCLUDINGTAX": "totalAmountIncludingTax",
                        "STATUS": "status",
                        "LASTMODIFIEDDATETIME": "lastModifiedDateTime"
                    },
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'purchase_invoice_id':
                        (str,),
                    'expand':
                        ([str],),
                    'select':
                        ([str],),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'purchase_invoice_id': 'purchaseInvoice_id',
                    'expand': '$expand',
                    'select': '$select',
                },
                'location_map': {
                    'company_id': 'path',
                    'purchase_invoice_id': 'path',
                    'expand': 'query',
                    'select': 'query',
                },
                'collection_format_map': {
                    'expand': 'csv',
                    'select': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_purchase_invoices_endpoint = _Endpoint(
            settings={
                'response_type': (InlineResponse2008,),
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/purchaseInvoices',
                'operation_id': 'list_purchase_invoices',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'top',
                    'skip',
                    'limit',
                    'filter',
                    'expand',
                    'select',
                ],
                'required': [
                    'company_id',
                ],
                'nullable': [
                ],
                'enum': [
                    'expand',
                    'select',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('expand',): {

                        "PURCHASEINVOICELINES": "purchaseInvoiceLines",
                        "PDFDOCUMENT": "pdfDocument",
                        "VENDOR": "vendor",
                        "CURRENCY": "currency"
                    },
                    ('select',): {

                        "ID": "id",
                        "NUMBER": "number",
                        "INVOICEDATE": "invoiceDate",
                        "DUEDATE": "dueDate",
                        "VENDORINVOICENUMBER": "vendorInvoiceNumber",
                        "VENDORID": "vendorId",
                        "VENDORNUMBER": "vendorNumber",
                        "VENDORNAME": "vendorName",
                        "PAYTONAME": "payToName",
                        "PAYTOCONTACT": "payToContact",
                        "PAYTOVENDORID": "payToVendorId",
                        "PAYTOVENDORNUMBER": "payToVendorNumber",
                        "SHIPTONAME": "shipToName",
                        "SHIPTOCONTACT": "shipToContact",
                        "BUYFROMADDRESS": "buyFromAddress",
                        "PAYTOADDRESS": "payToAddress",
                        "SHIPTOADDRESS": "shipToAddress",
                        "CURRENCYID": "currencyId",
                        "CURRENCYCODE": "currencyCode",
                        "PRICESINCLUDETAX": "pricesIncludeTax",
                        "DISCOUNTAMOUNT": "discountAmount",
                        "DISCOUNTAPPLIEDBEFORETAX": "discountAppliedBeforeTax",
                        "TOTALAMOUNTEXCLUDINGTAX": "totalAmountExcludingTax",
                        "TOTALTAXAMOUNT": "totalTaxAmount",
                        "TOTALAMOUNTINCLUDINGTAX": "totalAmountIncludingTax",
                        "STATUS": "status",
                        "LASTMODIFIEDDATETIME": "lastModifiedDateTime"
                    },
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'top':
                        (int,),
                    'skip':
                        (int,),
                    'limit':
                        (int,),
                    'filter':
                        (str,),
                    'expand':
                        ([str],),
                    'select':
                        ([str],),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'top': '$top',
                    'skip': '$skip',
                    'limit': '$limit',
                    'filter': '$filter',
                    'expand': '$expand',
                    'select': '$select',
                },
                'location_map': {
                    'company_id': 'path',
                    'top': 'query',
                    'skip': 'query',
                    'limit': 'query',
                    'filter': 'query',
                    'expand': 'query',
                    'select': 'query',
                },
                'collection_format_map': {
                    'expand': 'csv',
                    'select': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.patch_purchase_invoice_endpoint = _Endpoint(
            settings={
                'response_type': (PurchaseInvoice,),
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/purchaseInvoices({purchaseInvoice_id})',
                'operation_id': 'patch_purchase_invoice',
                'http_method': 'PATCH',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'purchase_invoice_id',
                    'content_type',
                    'if_match',
                    'purchase_invoice',
                ],
                'required': [
                    'company_id',
                    'purchase_invoice_id',
                    'content_type',
                    'if_match',
                    'purchase_invoice',
                ],
                'nullable': [
                    'purchase_invoice',
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'purchase_invoice_id':
                        (str,),
                    'content_type':
                        (str,),
                    'if_match':
                        (str,),
                    'purchase_invoice':
                        (PurchaseInvoice,),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'purchase_invoice_id': 'purchaseInvoice_id',
                    'content_type': 'Content-Type',
                    'if_match': 'If-Match',
                },
                'location_map': {
                    'company_id': 'path',
                    'purchase_invoice_id': 'path',
                    'content_type': 'header',
                    'if_match': 'header',
                    'purchase_invoice': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.post_purchase_invoice_endpoint = _Endpoint(
            settings={
                'response_type': (PurchaseInvoice,),
                'auth': [
                    'oAuth'
                ],
                'endpoint_path': '/companies({company_id})/purchaseInvoices',
                'operation_id': 'post_purchase_invoice',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'company_id',
                    'content_type',
                    'purchase_invoice',
                    'expand',
                ],
                'required': [
                    'company_id',
                    'content_type',
                    'purchase_invoice',
                ],
                'nullable': [
                    'purchase_invoice',
                ],
                'enum': [
                    'expand',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('expand',): {

                        "PURCHASEINVOICELINES": "purchaseInvoiceLines",
                        "PAYMENTTERM": "paymentTerm",
                        "PDFDOCUMENT": "pdfDocument",
                        "VENDOR": "vendor",
                        "CURRENCY": "currency"
                    },
                },
                'openapi_types': {
                    'company_id':
                        (str,),
                    'content_type':
                        (str,),
                    'purchase_invoice':
                        (PurchaseInvoice,),
                    'expand':
                        ([str],),
                },
                'attribute_map': {
                    'company_id': 'company_id',
                    'content_type': 'Content-Type',
                    'expand': '$expand',
                },
                'location_map': {
                    'company_id': 'path',
                    'content_type': 'header',
                    'purchase_invoice': 'body',
                    'expand': 'query',
                },
                'collection_format_map': {
                    'expand': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def delete_purchase_invoice(
        self,
        company_id,
        purchase_invoice_id,
        **kwargs
    ):
        """Deletes an object of type purchaseInvoice in Dynamics 365 Business Central  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_purchase_invoice(company_id, purchase_invoice_id, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company
            purchase_invoice_id (str): (v1.0) id for purchaseInvoice

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        kwargs['purchase_invoice_id'] = \
            purchase_invoice_id
        return self.delete_purchase_invoice_endpoint.call_with_http_info(**kwargs)

    def get_purchase_invoice(
        self,
        company_id,
        purchase_invoice_id,
        **kwargs
    ):
        """Retrieve the properties and relationships of an object of type purchaseInvoice for Dynamics 365 Business Central.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_purchase_invoice(company_id, purchase_invoice_id, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company
            purchase_invoice_id (str): (v1.0) id for purchaseInvoice

        Keyword Args:
            expand ([str]): (v1.0) Entities to expand. [optional]
            select ([str]): (v1.0) Selected properties to be retrieved. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PurchaseInvoice
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        kwargs['purchase_invoice_id'] = \
            purchase_invoice_id
        return self.get_purchase_invoice_endpoint.call_with_http_info(**kwargs)

    def list_purchase_invoices(
        self,
        company_id,
        **kwargs
    ):
        """Returns a list of purchaseInvoices  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_purchase_invoices(company_id, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company

        Keyword Args:
            top (int): (v1.0) Number of items to return from the top of the list. [optional]
            skip (int): (v1.0) Number of items to skip from the list. [optional]
            limit (int): (v1.0) Number of items to return from the list. [optional]
            filter (str): (v1.0) Filtering expression. [optional]
            expand ([str]): (v1.0) Entities to expand. [optional]
            select ([str]): (v1.0) Selected properties to be retrieved. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            InlineResponse2008
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        return self.list_purchase_invoices_endpoint.call_with_http_info(**kwargs)

    def patch_purchase_invoice(
        self,
        company_id,
        purchase_invoice_id,
        content_type,
        if_match,
        purchase_invoice,
        **kwargs
    ):
        """Updates an object of type purchaseInvoice in Dynamics 365 Business Central  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.patch_purchase_invoice(company_id, purchase_invoice_id, content_type, if_match, purchase_invoice, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company
            purchase_invoice_id (str): (v1.0) id for purchaseInvoice
            content_type (str): (v1.0) application/json
            if_match (str): (v1.0) Required. When this request header is included and the eTag provided does not match the current tag on the entity, this will not be updated.
            purchase_invoice (PurchaseInvoice):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PurchaseInvoice
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        kwargs['purchase_invoice_id'] = \
            purchase_invoice_id
        kwargs['content_type'] = \
            content_type
        kwargs['if_match'] = \
            if_match
        kwargs['purchase_invoice'] = \
            purchase_invoice
        return self.patch_purchase_invoice_endpoint.call_with_http_info(**kwargs)

    def post_purchase_invoice(
        self,
        company_id,
        content_type,
        purchase_invoice,
        **kwargs
    ):
        """Creates an object of type purchaseInvoice in Dynamics 365 Business Central  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.post_purchase_invoice(company_id, content_type, purchase_invoice, async_req=True)
        >>> result = thread.get()

        Args:
            company_id (str): (v1.0) id for company
            content_type (str): (v1.0) application/json
            purchase_invoice (PurchaseInvoice):

        Keyword Args:
            expand ([str]): (v1.0) Entities to expand. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PurchaseInvoice
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['company_id'] = \
            company_id
        kwargs['content_type'] = \
            content_type
        kwargs['purchase_invoice'] = \
            purchase_invoice
        return self.post_purchase_invoice_endpoint.call_with_http_info(**kwargs)

