"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from pybusinesscentral.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from pybusinesscentral.exceptions import ApiAttributeError


def lazy_import():
    from pybusinesscentral.model.default_dimensions import DefaultDimensions
    from pybusinesscentral.model.picture import Picture
    globals()['DefaultDimensions'] = DefaultDimensions
    globals()['Picture'] = Picture


class Item(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('number',): {
            'max_length': 20,
        },
        ('display_name',): {
            'max_length': 100,
        },
        ('item_category_code',): {
            'max_length': 20,
        },
        ('gtin',): {
            'max_length': 14,
        },
        ('tax_group_code',): {
            'max_length': 20,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'number': (str, none_type,),  # noqa: E501
            'display_name': (str, none_type,),  # noqa: E501
            'type': (str, none_type,),  # noqa: E501
            'item_category_id': (str, none_type,),  # noqa: E501
            'item_category_code': (str, none_type,),  # noqa: E501
            'blocked': (bool, none_type,),  # noqa: E501
            'base_unit_of_measure_id': (str, none_type,),  # noqa: E501
            'base_unit_of_measure': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'gtin': (str, none_type,),  # noqa: E501
            'inventory': (float, none_type,),  # noqa: E501
            'unit_price': (float, none_type,),  # noqa: E501
            'price_includes_tax': (bool, none_type,),  # noqa: E501
            'unit_cost': (float, none_type,),  # noqa: E501
            'tax_group_id': (str, none_type,),  # noqa: E501
            'tax_group_code': (str, none_type,),  # noqa: E501
            'last_modified_date_time': (datetime, none_type,),  # noqa: E501
            'picture': ([Picture], none_type,),  # noqa: E501
            'default_dimensions': ([DefaultDimensions], none_type,),  # noqa: E501
            'item_category': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'number': 'number',  # noqa: E501
        'display_name': 'displayName',  # noqa: E501
        'type': 'type',  # noqa: E501
        'item_category_id': 'itemCategoryId',  # noqa: E501
        'item_category_code': 'itemCategoryCode',  # noqa: E501
        'blocked': 'blocked',  # noqa: E501
        'base_unit_of_measure_id': 'baseUnitOfMeasureId',  # noqa: E501
        'base_unit_of_measure': 'baseUnitOfMeasure',  # noqa: E501
        'gtin': 'gtin',  # noqa: E501
        'inventory': 'inventory',  # noqa: E501
        'unit_price': 'unitPrice',  # noqa: E501
        'price_includes_tax': 'priceIncludesTax',  # noqa: E501
        'unit_cost': 'unitCost',  # noqa: E501
        'tax_group_id': 'taxGroupId',  # noqa: E501
        'tax_group_code': 'taxGroupCode',  # noqa: E501
        'last_modified_date_time': 'lastModifiedDateTime',  # noqa: E501
        'picture': 'picture',  # noqa: E501
        'default_dimensions': 'defaultDimensions',  # noqa: E501
        'item_category': 'itemCategory',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """Item - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): (v1.0) The id property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            number (str, none_type): (v1.0) The number property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            display_name (str, none_type): (v1.0) The displayName property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            type (str, none_type): (v1.0) The type property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            item_category_id (str, none_type): (v1.0) The itemCategoryId property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            item_category_code (str, none_type): (v1.0) The itemCategoryCode property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            blocked (bool, none_type): (v1.0) The blocked property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            base_unit_of_measure_id (str, none_type): (v1.0) The baseUnitOfMeasureId property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            base_unit_of_measure (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            gtin (str, none_type): (v1.0) The gtin property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            inventory (float, none_type): (v1.0) The inventory property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            unit_price (float, none_type): (v1.0) The unitPrice property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            price_includes_tax (bool, none_type): (v1.0) The priceIncludesTax property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            unit_cost (float, none_type): (v1.0) The unitCost property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            tax_group_id (str, none_type): (v1.0) The taxGroupId property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            tax_group_code (str, none_type): (v1.0) The taxGroupCode property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            last_modified_date_time (datetime, none_type): (v1.0) The lastModifiedDateTime property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            picture ([Picture], none_type): [optional]  # noqa: E501
            default_dimensions ([DefaultDimensions], none_type): [optional]  # noqa: E501
            item_category (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Item - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): (v1.0) The id property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            number (str, none_type): (v1.0) The number property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            display_name (str, none_type): (v1.0) The displayName property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            type (str, none_type): (v1.0) The type property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            item_category_id (str, none_type): (v1.0) The itemCategoryId property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            item_category_code (str, none_type): (v1.0) The itemCategoryCode property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            blocked (bool, none_type): (v1.0) The blocked property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            base_unit_of_measure_id (str, none_type): (v1.0) The baseUnitOfMeasureId property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            base_unit_of_measure (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            gtin (str, none_type): (v1.0) The gtin property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            inventory (float, none_type): (v1.0) The inventory property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            unit_price (float, none_type): (v1.0) The unitPrice property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            price_includes_tax (bool, none_type): (v1.0) The priceIncludesTax property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            unit_cost (float, none_type): (v1.0) The unitCost property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            tax_group_id (str, none_type): (v1.0) The taxGroupId property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            tax_group_code (str, none_type): (v1.0) The taxGroupCode property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            last_modified_date_time (datetime, none_type): (v1.0) The lastModifiedDateTime property for the Dynamics 365 Business Central item entity. [optional]  # noqa: E501
            picture ([Picture], none_type): [optional]  # noqa: E501
            default_dimensions ([DefaultDimensions], none_type): [optional]  # noqa: E501
            item_category (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
