"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from pybusinesscentral.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from pybusinesscentral.exceptions import ApiAttributeError



class SalesOrderLine(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('id',): {
            'max_length': 50,
        },
        ('description',): {
            'max_length': 100,
        },
        ('tax_code',): {
            'max_length': 50,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'id': (str,),  # noqa: E501
            'document_id': (str, none_type,),  # noqa: E501
            'sequence': (int, none_type,),  # noqa: E501
            'item_id': (str, none_type,),  # noqa: E501
            'account_id': (str, none_type,),  # noqa: E501
            'line_type': (str, none_type,),  # noqa: E501
            'line_details': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'description': (str, none_type,),  # noqa: E501
            'unit_of_measure_id': (str, none_type,),  # noqa: E501
            'unit_of_measure': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'quantity': (float, none_type,),  # noqa: E501
            'unit_price': (float, none_type,),  # noqa: E501
            'discount_amount': (float, none_type,),  # noqa: E501
            'discount_percent': (float, none_type,),  # noqa: E501
            'discount_applied_before_tax': (bool, none_type,),  # noqa: E501
            'amount_excluding_tax': (float, none_type,),  # noqa: E501
            'tax_code': (str, none_type,),  # noqa: E501
            'tax_percent': (float, none_type,),  # noqa: E501
            'total_tax_amount': (float, none_type,),  # noqa: E501
            'amount_including_tax': (float, none_type,),  # noqa: E501
            'invoice_discount_allocation': (float, none_type,),  # noqa: E501
            'net_amount': (float, none_type,),  # noqa: E501
            'net_tax_amount': (float, none_type,),  # noqa: E501
            'net_amount_including_tax': (float, none_type,),  # noqa: E501
            'shipment_date': (date, none_type,),  # noqa: E501
            'shipped_quantity': (float, none_type,),  # noqa: E501
            'invoiced_quantity': (float, none_type,),  # noqa: E501
            'invoice_quantity': (float, none_type,),  # noqa: E501
            'ship_quantity': (float, none_type,),  # noqa: E501
            'item': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'account': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'document_id': 'documentId',  # noqa: E501
        'sequence': 'sequence',  # noqa: E501
        'item_id': 'itemId',  # noqa: E501
        'account_id': 'accountId',  # noqa: E501
        'line_type': 'lineType',  # noqa: E501
        'line_details': 'lineDetails',  # noqa: E501
        'description': 'description',  # noqa: E501
        'unit_of_measure_id': 'unitOfMeasureId',  # noqa: E501
        'unit_of_measure': 'unitOfMeasure',  # noqa: E501
        'quantity': 'quantity',  # noqa: E501
        'unit_price': 'unitPrice',  # noqa: E501
        'discount_amount': 'discountAmount',  # noqa: E501
        'discount_percent': 'discountPercent',  # noqa: E501
        'discount_applied_before_tax': 'discountAppliedBeforeTax',  # noqa: E501
        'amount_excluding_tax': 'amountExcludingTax',  # noqa: E501
        'tax_code': 'taxCode',  # noqa: E501
        'tax_percent': 'taxPercent',  # noqa: E501
        'total_tax_amount': 'totalTaxAmount',  # noqa: E501
        'amount_including_tax': 'amountIncludingTax',  # noqa: E501
        'invoice_discount_allocation': 'invoiceDiscountAllocation',  # noqa: E501
        'net_amount': 'netAmount',  # noqa: E501
        'net_tax_amount': 'netTaxAmount',  # noqa: E501
        'net_amount_including_tax': 'netAmountIncludingTax',  # noqa: E501
        'shipment_date': 'shipmentDate',  # noqa: E501
        'shipped_quantity': 'shippedQuantity',  # noqa: E501
        'invoiced_quantity': 'invoicedQuantity',  # noqa: E501
        'invoice_quantity': 'invoiceQuantity',  # noqa: E501
        'ship_quantity': 'shipQuantity',  # noqa: E501
        'item': 'item',  # noqa: E501
        'account': 'account',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """SalesOrderLine - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): (v1.0) The id property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            document_id (str, none_type): (v1.0) The documentId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            sequence (int, none_type): (v1.0) The sequence property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            item_id (str, none_type): (v1.0) The itemId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            account_id (str, none_type): (v1.0) The accountId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            line_type (str, none_type): (v1.0) The lineType property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            line_details (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            description (str, none_type): (v1.0) The description property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            unit_of_measure_id (str, none_type): (v1.0) The unitOfMeasureId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            unit_of_measure (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            quantity (float, none_type): (v1.0) The quantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            unit_price (float, none_type): (v1.0) The unitPrice property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            discount_amount (float, none_type): (v1.0) The discountAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            discount_percent (float, none_type): (v1.0) The discountPercent property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            discount_applied_before_tax (bool, none_type): (v1.0) The discountAppliedBeforeTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            amount_excluding_tax (float, none_type): (v1.0) The amountExcludingTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            tax_code (str, none_type): (v1.0) The taxCode property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            tax_percent (float, none_type): (v1.0) The taxPercent property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            total_tax_amount (float, none_type): (v1.0) The totalTaxAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            amount_including_tax (float, none_type): (v1.0) The amountIncludingTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            invoice_discount_allocation (float, none_type): (v1.0) The invoiceDiscountAllocation property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            net_amount (float, none_type): (v1.0) The netAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            net_tax_amount (float, none_type): (v1.0) The netTaxAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            net_amount_including_tax (float, none_type): (v1.0) The netAmountIncludingTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            shipment_date (date, none_type): (v1.0) The shipmentDate property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            shipped_quantity (float, none_type): (v1.0) The shippedQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            invoiced_quantity (float, none_type): (v1.0) The invoicedQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            invoice_quantity (float, none_type): (v1.0) The invoiceQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            ship_quantity (float, none_type): (v1.0) The shipQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            item (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            account (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SalesOrderLine - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): (v1.0) The id property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            document_id (str, none_type): (v1.0) The documentId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            sequence (int, none_type): (v1.0) The sequence property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            item_id (str, none_type): (v1.0) The itemId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            account_id (str, none_type): (v1.0) The accountId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            line_type (str, none_type): (v1.0) The lineType property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            line_details (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            description (str, none_type): (v1.0) The description property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            unit_of_measure_id (str, none_type): (v1.0) The unitOfMeasureId property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            unit_of_measure (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            quantity (float, none_type): (v1.0) The quantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            unit_price (float, none_type): (v1.0) The unitPrice property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            discount_amount (float, none_type): (v1.0) The discountAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            discount_percent (float, none_type): (v1.0) The discountPercent property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            discount_applied_before_tax (bool, none_type): (v1.0) The discountAppliedBeforeTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            amount_excluding_tax (float, none_type): (v1.0) The amountExcludingTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            tax_code (str, none_type): (v1.0) The taxCode property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            tax_percent (float, none_type): (v1.0) The taxPercent property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            total_tax_amount (float, none_type): (v1.0) The totalTaxAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            amount_including_tax (float, none_type): (v1.0) The amountIncludingTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            invoice_discount_allocation (float, none_type): (v1.0) The invoiceDiscountAllocation property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            net_amount (float, none_type): (v1.0) The netAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            net_tax_amount (float, none_type): (v1.0) The netTaxAmount property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            net_amount_including_tax (float, none_type): (v1.0) The netAmountIncludingTax property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            shipment_date (date, none_type): (v1.0) The shipmentDate property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            shipped_quantity (float, none_type): (v1.0) The shippedQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            invoiced_quantity (float, none_type): (v1.0) The invoicedQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            invoice_quantity (float, none_type): (v1.0) The invoiceQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            ship_quantity (float, none_type): (v1.0) The shipQuantity property for the Dynamics 365 Business Central salesOrderLine entity. [optional]  # noqa: E501
            item (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            account (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
